require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_SYS_EPOCH_PRIVATE_H_)) {
    eval 'sub _SYS_EPOCH_PRIVATE_H_ () {1;}' unless defined(&_SYS_EPOCH_PRIVATE_H_);
    unless(defined(&_KERNEL)) {
	die("no user serviceable parts");
    } else {
	require 'ck_epoch.ph';
	require 'sys/kpilite.ph';
	require 'sys/mutex.ph';
	unless(defined(&_SYS_SYSTM_H_)) {
	}
	if(defined(&__amd64__)) {
	    eval 'sub EPOCH_ALIGN () { &CACHE_LINE_SIZE*2;}' unless defined(&EPOCH_ALIGN);
	} else {
	    eval 'sub EPOCH_ALIGN () { &CACHE_LINE_SIZE;}' unless defined(&EPOCH_ALIGN);
	}
	eval 'sub critical_exit_sa {
	    my($tdarg) = @_;
    	    eval q({ \'struct thread_lite\' * &td;  &td = $tdarg;  &MPASS( ($td->{td_critnest}) > 0);  &__compiler_membar();  ($td->{td_critnest})--;  &__compiler_membar();  &if ( &__predict_false( ($td->{td_owepreempt}) != 0))  &critical_exit_preempt(); });
	}' unless defined(&critical_exit_sa);
	if(defined(&EPOCH_TRACKER_DEBUG)) {
	}
	if(defined(&EPOCH_TRACKER_DEBUG)) {
	}
	eval 'sub INIT_CHECK {
	    my($epoch) = @_;
    	    eval q( &do {  &if ( &__predict_false(($epoch) ==  &NULL))  &return; }  &while (0));
	}' unless defined(&INIT_CHECK);
# some #ifdef were dropped here -- fill in the blanks
	eval 'sub epoch_enter_preempt {
	    my($epoch,$et) = @_;
    	    eval q({ \'struct epoch_record\' * &er; \'struct epoch_thread\' * &etd; \'struct thread_lite\' * &td;  &MPASS( &cold || $epoch !=  &NULL);  &INIT_CHECK($epoch);  &etd = ( &void *)$et;  &MPASS( ($epoch->{e_flags}) &  &EPOCH_PREEMPT);  &td =  &curthread;  ($etd->{et_td}) = ( &void*) &td;  ($td->{td_epochnest})++;  &critical_enter_sa( &td);  &sched_pin_lite( &td);  ($td->{td_pre_epoch_prio}) =  ($td->{td_priority});  &er =  &epoch_currecord($epoch);  &TAILQ_INSERT_TAIL( ($er->{er_tdlist}),  &etd,  &et_link);  &ck_epoch_begin( ($er->{er_record}), ( &ck_epoch_section_t *) ($etd->{et_section}));  &critical_exit_sa( &td); });
	}' unless defined(&epoch_enter_preempt);
	eval 'sub epoch_enter {
	    my($epoch) = @_;
    	    eval q({ \'struct thread_lite\' * &td;  &epoch_record_t  &er;  &MPASS( &cold || $epoch !=  &NULL);  &INIT_CHECK($epoch);  &td =  &curthread;  ($td->{td_epochnest})++;  &critical_enter_sa( &td);  &er =  &epoch_currecord($epoch);  &ck_epoch_begin( ($er->{er_record}),  &NULL); });
	}' unless defined(&epoch_enter);
# some #ifdef were dropped here -- fill in the blanks
	eval 'sub epoch_exit_preempt {
	    my($epoch,$et) = @_;
    	    eval q({ \'struct epoch_record\' * &er; \'struct epoch_thread\' * &etd; \'struct thread_lite\' * &td;  &INIT_CHECK($epoch);  &td =  &curthread;  &critical_enter_sa( &td);  &sched_unpin_lite( &td);  &MPASS( ($td->{td_epochnest}));  ($td->{td_epochnest})--;  &er =  &epoch_currecord($epoch);  &MPASS( ($epoch->{e_flags}) &  &EPOCH_PREEMPT);  &etd = ( &void *)$et;  &MPASS( &etd !=  &NULL);  &MPASS( ($etd->{et_td}) ==  &td);  ($etd->{et_td}) = ( &void*)0xdeadbeef;  &ck_epoch_end( ($er->{er_record}), ( &ck_epoch_section_t *) ($etd->{et_section}));  &TAILQ_REMOVE( ($er->{er_tdlist}),  &etd,  &et_link);  ($er->{er_gen})++;  &if ( &__predict_false( ($td->{td_pre_epoch_prio}) !=  ($td->{td_priority})))  &epoch_adjust_prio( &td,  ($td->{td_pre_epoch_prio}));  &critical_exit_sa( &td); });
	}' unless defined(&epoch_exit_preempt);
	eval 'sub epoch_exit {
	    my($epoch) = @_;
    	    eval q({ \'struct thread_lite\' * &td;  &epoch_record_t  &er;  &INIT_CHECK($epoch);  &td =  &curthread;  &MPASS( ($td->{td_epochnest}));  ($td->{td_epochnest})--;  &er =  &epoch_currecord($epoch);  &ck_epoch_end( ($er->{er_record}),  &NULL);  &critical_exit_sa( &td); });
	}' unless defined(&epoch_exit);
    }
}
1;
